searchNodes=[{"doc":"Alternative implementation of functions in Caustic.Utils .","ref":"Caustic.Alt.html","title":"Caustic.Alt","type":"module"},{"doc":"","ref":"Caustic.Alt.html#pow/2","title":"Caustic.Alt.pow/2","type":"function"},{"doc":"","ref":"Caustic.Alt.html#prime?/1","title":"Caustic.Alt.prime?/1","type":"function"},{"doc":"Represents an elliptic curve point y^2 = x^3 + ax + b .","ref":"Caustic.ECPoint.html","title":"Caustic.ECPoint","type":"module"},{"doc":"Addition of points in an elliptic curve. Examples iex&gt; Caustic.ECPoint . add ( Caustic.ECPoint . make ( - 1 , - 1 , 5 , 7 ) , Caustic.ECPoint . infinity ( 5 , 7 ) ) { - 1 , - 1 , 5 , 7 } iex&gt; Caustic.ECPoint . add ( Caustic.ECPoint . infinity ( 5 , 7 ) , Caustic.ECPoint . make ( - 1 , - 1 , 5 , 7 ) ) { - 1 , - 1 , 5 , 7 } iex&gt; Caustic.ECPoint . add ( Caustic.ECPoint . make ( - 1 , 1 , 5 , 7 ) , Caustic.ECPoint . make ( - 1 , - 1 , 5 , 7 ) ) { nil , nil , 5 , 7 } iex&gt; p = 223 iex&gt; a = { 0 , p } iex&gt; b = { 7 , p } iex&gt; x1 = { 192 , p } iex&gt; y1 = { 105 , p } iex&gt; x2 = { 17 , p } iex&gt; y2 = { 56 , p } iex&gt; p1 = Caustic.ECPoint . make ( x1 , y1 , a , b ) iex&gt; p2 = Caustic.ECPoint . make ( x2 , y2 , a , b ) iex&gt; Caustic.ECPoint . add ( p1 , p2 ) { { 170 , 223 } , { 142 , 223 } , { 0 , 223 } , { 7 , 223 } } iex&gt; p = 223 iex&gt; a = { 0 , p } iex&gt; b = { 7 , p } iex&gt; x = { 47 , p } iex&gt; y = { 71 , p } iex&gt; p = Caustic.ECPoint . make ( x , y , a , b ) iex&gt; Caustic.ECPoint . add ( p , p ) { { 36 , 223 } , { 111 , 223 } , { 0 , 223 } , { 7 , 223 } } iex&gt; a = { 0 , 223 } iex&gt; b = { 7 , 223 } iex&gt; i = Caustic.ECPoint . infinity ( a , b ) iex&gt; Caustic.ECPoint . add ( i , i ) { nil , nil , { 0 , 223 } , { 7 , 223 } }","ref":"Caustic.ECPoint.html#add/2","title":"Caustic.ECPoint.add/2","type":"function"},{"doc":"Check whether two points in an elliptic field is equal. Examples iex&gt; Caustic.ECPoint . eq? ( { - 1 , - 1 , 5 , 7 } , { - 1 , - 1 , 5 , 7 } ) true","ref":"Caustic.ECPoint.html#eq?/2","title":"Caustic.ECPoint.eq?/2","type":"function"},{"doc":"Find points on an elliptic curve. Examples iex&gt; Caustic.ECPoint . find_points ( - 100 , 5 , 7 ) [ ] iex&gt; Caustic.ECPoint . find_points ( - 1.0 , 5 , 7 ) [ { - 1.0 , 1.0 , 5 , 7 } , { - 1.0 , - 1.0 , 5 , 7 } ]","ref":"Caustic.ECPoint.html#find_points/3","title":"Caustic.ECPoint.find_points/3","type":"function"},{"doc":"Create point of infinity in an elliptic curve y^2 = x^3 + ax + b. Examples iex&gt; Caustic.ECPoint . infinity ( 5 , 7 ) { nil , nil , 5 , 7 }","ref":"Caustic.ECPoint.html#infinity/2","title":"Caustic.ECPoint.infinity/2","type":"function"},{"doc":"Create a point in an elliptic field. Examples iex&gt; Caustic.ECPoint . make ( - 1 , 1 , 5 , 7 ) { - 1 , 1 , 5 , 7 } iex&gt; Caustic.ECPoint . make ( - 1 , - 1 , 5 , 7 ) { - 1 , - 1 , 5 , 7 } iex&gt; Caustic.ECPoint . make ( { 17 , 103 } , { 64 , 103 } , { 0 , 103 } , { 7 , 103 } ) { { 17 , 103 } , { 64 , 103 } , { 0 , 103 } , { 7 , 103 } } iex&gt; Caustic.ECPoint . make ( { 192 , 223 } , { 105 , 223 } , { 0 , 223 } , { 7 , 223 } ) { { 192 , 223 } , { 105 , 223 } , { 0 , 223 } , { 7 , 223 } } iex&gt; Caustic.ECPoint . make ( { 17 , 223 } , { 56 , 223 } , { 0 , 223 } , { 7 , 223 } ) { { 17 , 223 } , { 56 , 223 } , { 0 , 223 } , { 7 , 223 } }","ref":"Caustic.ECPoint.html#make/4","title":"Caustic.ECPoint.make/4","type":"function"},{"doc":"Examples iex&gt; p = 223 iex&gt; a = { 0 , p } iex&gt; b = { 7 , p } iex&gt; x = { 47 , p } iex&gt; y = { 71 , p } iex&gt; g = Caustic.ECPoint . make ( x , y , a , b ) iex&gt; Caustic.ECPoint . mul ( 2 , g ) { { 36 , 223 } , { 111 , 223 } , { 0 , 223 } , { 7 , 223 } } iex&gt; g = { { 15 , 223 } , { 86 , 223 } , { 0 , 223 } , { 7 , 223 } } iex&gt; Caustic.ECPoint . mul ( 0 , g ) { nil , nil , { 0 , 223 } , { 7 , 223 } }","ref":"Caustic.ECPoint.html#mul/2","title":"Caustic.ECPoint.mul/2","type":"function"},{"doc":"Check whether two points in an elliptic field is not equal. Examples iex&gt; Caustic.ECPoint . ne? ( { - 1 , 1 , 5 , 7 } , { - 1 , - 1 , 5 , 7 } ) true","ref":"Caustic.ECPoint.html#ne?/2","title":"Caustic.ECPoint.ne?/2","type":"function"},{"doc":"Step-by-step explanation of the computation in Caustic.Utils .","ref":"Caustic.Explain.html","title":"Caustic.Explain","type":"module"},{"doc":"","ref":"Caustic.Explain.html#linear_congruence_solve/3","title":"Caustic.Explain.linear_congruence_solve/3","type":"function"},{"doc":"","ref":"Caustic.Explain.html#totient/1","title":"Caustic.Explain.totient/1","type":"function"},{"doc":"Protocol on field operations. Mainly to support Caustic.FiniteField .","ref":"Caustic.Field.html","title":"Caustic.Field","type":"protocol"},{"doc":"Examples iex&gt; Caustic.Field . add ( { 7 , 13 } , { 12 , 13 } ) { 6 , 13 }","ref":"Caustic.Field.html#add/2","title":"Caustic.Field.add/2","type":"function"},{"doc":"Examples iex&gt; Caustic.Field . div ( { 2 , 5 } , { 4 , 5 } ) { 3 , 5 } iex&gt; Caustic.Field . div ( { 1 , 5 } , { 2 , 5 } ) { 3 , 5 }","ref":"Caustic.Field.html#div/2","title":"Caustic.Field.div/2","type":"function"},{"doc":"Examples iex&gt; Caustic.Field . eq? ( { 7 , 13 } , { 7 , 13 } ) true iex&gt; Caustic.Field . eq? ( { 7 , 13 } , { 6 , 13 } ) false iex&gt; Caustic.Field . eq? ( { 7 , 13 } , { 7 , 11 } ) false","ref":"Caustic.Field.html#eq?/2","title":"Caustic.Field.eq?/2","type":"function"},{"doc":"Examples iex&gt; Caustic.Field . inverse ( { 1 , 71 } ) { 1 , 71 } iex&gt; Caustic.Field . inverse ( { 51 , 71 } ) { 39 , 71 } iex&gt; Caustic.Field . inverse ( { 39 , 71 } ) { 51 , 71 } iex&gt; Caustic.Field . mul ( { 51 , 71 } , { 39 , 71 } ) { 1 , 71 } iex&gt; Caustic.Field . inverse ( { 0 , 71 } ) nil","ref":"Caustic.Field.html#inverse/1","title":"Caustic.Field.inverse/1","type":"function"},{"doc":"Examples iex&gt; Caustic.Field . mul ( { 5 , 19 } , { 3 , 19 } ) { 15 , 19 } iex&gt; Caustic.Field . mul ( { 8 , 19 } , { 17 , 19 } ) { 3 , 19 }","ref":"Caustic.Field.html#mul/2","title":"Caustic.Field.mul/2","type":"function"},{"doc":"Examples iex&gt; Caustic.Field . ne? ( { 7 , 13 } , { 7 , 13 } ) false iex&gt; Caustic.Field . ne? ( { 7 , 13 } , { 6 , 13 } ) true iex&gt; Caustic.Field . ne? ( { 7 , 13 } , { 7 , 11 } ) true","ref":"Caustic.Field.html#ne?/2","title":"Caustic.Field.ne?/2","type":"function"},{"doc":"","ref":"Caustic.Field.html#neg/1","title":"Caustic.Field.neg/1","type":"function"},{"doc":"Examples iex&gt; Caustic.Field . pow ( { 7 , 19 } , { 3 , 19 } ) { 1 , 19 } iex&gt; Caustic.Field . pow ( { 9 , 19 } , { 12 , 19 } ) { 7 , 19 }","ref":"Caustic.Field.html#pow/2","title":"Caustic.Field.pow/2","type":"function"},{"doc":"","ref":"Caustic.Field.html#sqrt/1","title":"Caustic.Field.sqrt/1","type":"function"},{"doc":"Examples iex&gt; Caustic.Field . sub ( { 7 , 13 } , { 12 , 13 } ) { 8 , 13 }","ref":"Caustic.Field.html#sub/2","title":"Caustic.Field.sub/2","type":"function"},{"doc":"Check if it is the additive identity. Examples iex&gt; Caustic.Field . zero? ( 0 ) true iex&gt; Caustic.Field . zero? ( 0.0 ) true iex&gt; Caustic.Field . zero? ( { 0 , 5 } ) true","ref":"Caustic.Field.html#zero?/1","title":"Caustic.Field.zero?/1","type":"function"},{"doc":"","ref":"Caustic.Field.html#t:t/0","title":"Caustic.Field.t/0","type":"type"},{"doc":"Module for the creation of finite field element. For the supported operations, see Caustic.Field . Examples # Represents 1 which is a member of finite field of order 5 iex&gt; Caustic.FiniteField . make ( 1 , 5 ) { 1 , 5 } # Modulo addition 1 + 4 mod 5 iex&gt; Caustic.Field . add ( { 1 , 5 } , { 4 , 5 } ) { 0 , 5 } # Test for congruence 4 * 4 ≡ 1 (mod 5) iex&gt; Caustic.Field . mul ( { 4 , 5 } , { 4 , 5 } ) |&gt; Caustic.Field . eq? ( { 1 , 5 } ) true","ref":"Caustic.FiniteField.html","title":"Caustic.FiniteField","type":"module"},{"doc":"","ref":"Caustic.FiniteField.html#make/2","title":"Caustic.FiniteField.make/2","type":"function"},{"doc":"","ref":"Caustic.FiniteField.html#to_string/1","title":"Caustic.FiniteField.to_string/1","type":"function"},{"doc":"","ref":"Caustic.FiniteField.html#t:finite_field_elem/0","title":"Caustic.FiniteField.finite_field_elem/0","type":"type"},{"doc":"Formatting for beautiful layout of equations and tables.","ref":"Caustic.Format.html","title":"Caustic.Format","type":"module"},{"doc":"Examples iex&gt; Caustic.Format . equations [ &quot;x&quot; , &quot;1 + 1 + 1&quot; , &quot;1 + 2&quot; , &quot;3&quot; ] &quot;x = 1 + 1 + 1 \\n = 1 + 2 \\n = 3&quot;","ref":"Caustic.Format.html#equations/1","title":"Caustic.Format.equations/1","type":"function"},{"doc":"","ref":"Caustic.Format.html#print_equations/1","title":"Caustic.Format.print_equations/1","type":"function"},{"doc":"","ref":"Caustic.Format.html#print_exponentiation_table_mod/2","title":"Caustic.Format.print_exponentiation_table_mod/2","type":"function"},{"doc":"","ref":"Caustic.Format.html#print_fn/2","title":"Caustic.Format.print_fn/2","type":"function"},{"doc":"","ref":"Caustic.Format.html#print_fn/3","title":"Caustic.Format.print_fn/3","type":"function"},{"doc":"","ref":"Caustic.Format.html#print_fn/4","title":"Caustic.Format.print_fn/4","type":"function"},{"doc":"","ref":"Caustic.Format.html#print_multiplication_table_mod/1","title":"Caustic.Format.print_multiplication_table_mod/1","type":"function"},{"doc":"","ref":"Caustic.Format.html#print_table/3","title":"Caustic.Format.print_table/3","type":"function"},{"doc":"Examples iex&gt; Caustic.Format . table [ [ 2 , 3 ] , [ 1 , 4 ] ] , [ &quot;x + 1&quot; , &quot;x^2&quot; ] , [ 1 , 2 ] &quot; | 1 | 2 \\n x + 1 | 2 | 3 \\n x^2 | 1 | 4&quot;","ref":"Caustic.Format.html#table/3","title":"Caustic.Format.table/3","type":"function"},{"doc":"Implementation of the MD5 hash.","ref":"Caustic.Md5.html","title":"Caustic.Md5","type":"module"},{"doc":"Clip a number to 32-bit.","ref":"Caustic.Md5.html#clip/1","title":"Caustic.Md5.clip/1","type":"function"},{"doc":"The nonlinear function used in round 1 (of 4) of a block processing.","ref":"Caustic.Md5.html#f0/3","title":"Caustic.Md5.f0/3","type":"function"},{"doc":"The nonlinear function used in round 2 (of 4) of a block processing.","ref":"Caustic.Md5.html#f1/3","title":"Caustic.Md5.f1/3","type":"function"},{"doc":"The nonlinear function used in round 3 (of 4) of a block processing.","ref":"Caustic.Md5.html#f2/3","title":"Caustic.Md5.f2/3","type":"function"},{"doc":"The nonlinear function used in round 4 (of 4) of a block processing.","ref":"Caustic.Md5.html#f3/3","title":"Caustic.Md5.f3/3","type":"function"},{"doc":"Calculate the md5 hash of a message. Examples iex&gt; Caustic.Md5 . hash ( &quot;The quick brown fox jumps over the lazy dog&quot; ) &quot;9e107d9d372bb6826bd81d3542a419d6&quot; iex&gt; Caustic.Md5 . hash ( &quot;The quick brown fox jumps over the lazy dog.&quot; ) &quot;e4d909c290d0fb1ca068ffaddf22cbd0&quot; iex&gt; Caustic.Md5 . hash ( &quot;The quick brown fox jumps over the lazy dog. The quick brown fox jumps over the lazy dog.&quot; ) &quot;f168d89e05b664041ee6745f050caa4b&quot; iex&gt; Caustic.Md5 . hash ( &quot;&quot; ) &quot;d41d8cd98f00b204e9800998ecf8427e&quot; iex&gt; Caustic.Md5 . hash ( &quot;a&quot; ) &quot;0cc175b9c0f1b6a831c399e269772661&quot; iex&gt; Caustic.Md5 . hash ( &quot;abc&quot; ) &quot;900150983cd24fb0d6963f7d28e17f72&quot; iex&gt; Caustic.Md5 . hash ( &quot;12345678901234567890123456789012345678901234567890123456789012345678901234567890&quot; ) &quot;57edf4a22be3c955ac49da2e2107b67a&quot;","ref":"Caustic.Md5.html#hash/1","title":"Caustic.Md5.hash/1","type":"function"},{"doc":"Examples iex&gt; Caustic.Md5.hex_to_uint32_little_endian(&quot;6036708e&quot;) 2389718624","ref":"Caustic.Md5.html#hex_to_uint32_little_endian/1","title":"Caustic.Md5.hex_to_uint32_little_endian/1","type":"function"},{"doc":"Perform a length extension attack. https://blog.skullsecurity.org/2012/everything-you-need-to-know-about-hash-length-extension-attacks Examples iex&gt; secret = &quot;THE_SUPER_SECRET&quot; iex&gt; secret_length = byte_size ( secret ) iex&gt; message = &quot;action=delete&amp;id=123&quot; iex&gt; signature = Caustic.Md5 . hash ( secret &lt;&gt; message ) iex&gt; append = &quot;&amp;id=999&quot; iex&gt; message_attack = message &lt;&gt; &lt;&lt; 0x80 , 0x00 :: size ( 152 ) , ( secret_length + byte_size ( message ) ) * 8 :: little - size ( 64 ) &gt;&gt; &lt;&gt; append iex&gt; signature_attack = Caustic.Md5 . hash ( secret &lt;&gt; message_attack ) iex&gt; { message_attack , signature_attack } == Caustic.Md5 . length_extension_attack ( message , signature , secret_length , append ) true","ref":"Caustic.Md5.html#length_extension_attack/4","title":"Caustic.Md5.length_extension_attack/4","type":"function"},{"doc":"Pad a binary and append original message length at the end. The length field is a 64 bit in little endian encoding, so the written length is modulo 2^64. md5 only works with a block size in multiple of 512 bit, so the message is optionally padded such that message &lt;&gt; padding &lt;&gt; length is in that multiple. The padding is a single '1' bit followed by as much '0' bits as needed.","ref":"Caustic.Md5.html#pad/1","title":"Caustic.Md5.pad/1","type":"function"},{"doc":"Pad a binary with a single '1' bit and then with as much '0' bits as needed.","ref":"Caustic.Md5.html#pad_zero/2","title":"Caustic.Md5.pad_zero/2","type":"function"},{"doc":"Convenience functions for the elliptic curve secp256k1 used in Bitcoin.","ref":"Caustic.Secp256k1.html","title":"Caustic.Secp256k1","type":"module"},{"doc":"The constant a in the elliptic curve equation y^2 = x^3 + ax + b . Examples iex&gt; { a , _p } = Caustic.Secp256k1 . a ( ) iex&gt; a 0","ref":"Caustic.Secp256k1.html#a/0","title":"Caustic.Secp256k1.a/0","type":"function"},{"doc":"The constant b in the elliptic curve equation y^2 = x^3 + ax + b . Examples iex&gt; { b , _p } = Caustic.Secp256k1 . b ( ) iex&gt; b 7","ref":"Caustic.Secp256k1.html#b/0","title":"Caustic.Secp256k1.b/0","type":"function"},{"doc":"Signs a message using ECDSA. Arguments z : The hash of the signed message. Use Caustic.Utils.hash256 to hash your message. e : The private key. Examples iex&gt; message = &quot;Hello, world!!!&quot; iex&gt; z = Caustic.Utils . hash256 ( message ) iex&gt; e = Caustic.Secp256k1 . generate_private_key ( ) iex&gt; signature = Caustic.Secp256k1 . ecdsa_sign ( z , e ) iex&gt; pubkey = Caustic.Secp256k1 . public_key ( e ) iex&gt; Caustic.Secp256k1 . ecdsa_verify? ( pubkey , z , signature ) true","ref":"Caustic.Secp256k1.html#ecdsa_sign/2","title":"Caustic.Secp256k1.ecdsa_sign/2","type":"function"},{"doc":"Verifies whether a given ECDSA signature is correct. Arguments pubkey : The public key. z : The hash of the signed message. Use Caustic.Utils.hash256 to hash your message. sig : The signature in the format of {r, s} . Examples iex&gt; z = 0xbc62d4b80d9e36da29c16c5d4d9f11731f36052c72401a76c23c0fb5a9b74423 iex&gt; r = 0x37206a0610995c58074999cb9767b87af4c4978db68c06e8e6e81d282047a7c6 iex&gt; s = 0x8ca63759c1157ebeaec0d03cecca119fc9a75bf8e6d0fa65c841c8e2738cdaec iex&gt; pubkey_x = 0x04519fac3d910ca7e7138f7013706f619fa8f033e6ec6e09370ea38cee6a7574 iex&gt; pubkey_y = 0x82b51eab8c27c66e26c858a079bcdf4f1ada34cec420cafc7eac1a42216fb6c4 iex&gt; pubkey = Caustic.Secp256k1 . make_point ( pubkey_x , pubkey_y ) iex&gt; Caustic.Secp256k1 . ecdsa_verify? ( pubkey , z , { r , s } ) true","ref":"Caustic.Secp256k1.html#ecdsa_verify?/3","title":"Caustic.Secp256k1.ecdsa_verify?/3","type":"function"},{"doc":"The generator point G used in public key calculation P = eG . Examples iex&gt; g = Caustic.Secp256k1 . g ( ) iex&gt; n = Caustic.Secp256k1 . n ( ) iex&gt; Caustic.ECPoint . mul ( n , g ) == Caustic.Secp256k1 . make_point_infinity ( ) true","ref":"Caustic.Secp256k1.html#g/0","title":"Caustic.Secp256k1.g/0","type":"function"},{"doc":"The x component of the generator point G.","ref":"Caustic.Secp256k1.html#g_x/0","title":"Caustic.Secp256k1.g_x/0","type":"function"},{"doc":"The y component of the generator point G.","ref":"Caustic.Secp256k1.html#g_y/0","title":"Caustic.Secp256k1.g_y/0","type":"function"},{"doc":"Generate a random private key k with 1 &lt;= k &lt;= priv_key_max .","ref":"Caustic.Secp256k1.html#generate_private_key/0","title":"Caustic.Secp256k1.generate_private_key/0","type":"function"},{"doc":"","ref":"Caustic.Secp256k1.html#make_field_elem/1","title":"Caustic.Secp256k1.make_field_elem/1","type":"function"},{"doc":"Create a point in the secp256k1 curve. If you supply it with x and y coordinates outside of the curve it will throw an error.","ref":"Caustic.Secp256k1.html#make_point/2","title":"Caustic.Secp256k1.make_point/2","type":"function"},{"doc":"","ref":"Caustic.Secp256k1.html#make_point_infinity/0","title":"Caustic.Secp256k1.make_point_infinity/0","type":"function"},{"doc":"The number of possible private keys, because when you consider private keys e &gt;= n it will just loop to the same public keys.","ref":"Caustic.Secp256k1.html#n/0","title":"Caustic.Secp256k1.n/0","type":"function"},{"doc":"The order of the finite field used in secp256k1.","ref":"Caustic.Secp256k1.html#p/0","title":"Caustic.Secp256k1.p/0","type":"function"},{"doc":"The largest possible private key. Equals to the constant n - 1.","ref":"Caustic.Secp256k1.html#priv_key_max/0","title":"Caustic.Secp256k1.priv_key_max/0","type":"function"},{"doc":"Calculate the public key of a private key k .","ref":"Caustic.Secp256k1.html#public_key/1","title":"Caustic.Secp256k1.public_key/1","type":"function"},{"doc":"","ref":"Caustic.Secp256k1.html#to_string/1","title":"Caustic.Secp256k1.to_string/1","type":"function"},{"doc":"A collection of useful methods in cryptography and number theory.","ref":"Caustic.Utils.html","title":"Caustic.Utils","type":"module"},{"doc":"Checks whether an integer is abundant. An integer n is abundant if and only if σ(n) - n &gt; n . Examples iex&gt; Caustic.Utils . abundant? ( 6 ) false","ref":"Caustic.Utils.html#abundant?/1","title":"Caustic.Utils.abundant?/1","type":"function"},{"doc":"The other number of an amicable pair, if any. Returns nil if doesn't have such pair. Examples iex&gt; Caustic.Utils . amicable_pair ( 220 ) 284 iex&gt; Caustic.Utils . amicable_pair ( 2 ) nil","ref":"Caustic.Utils.html#amicable_pair/1","title":"Caustic.Utils.amicable_pair/1","type":"function"},{"doc":"","ref":"Caustic.Utils.html#base58_checksum/1","title":"Caustic.Utils.base58_checksum/1","type":"function"},{"doc":"Decode a base58-encoded string into its hexadecimal string representation. Examples iex&gt; Caustic.Utils . base58_decode ( &quot;5J3mBbAH58CpQ3Y5RNJpUKPE62SQ5tfcvU2JpbnkeyhfsYB1Jcn&quot; ) &quot;0x801e99423a4ed27608a15a2616a2b0e9e52ced330ac530edcc32c8ffc6a526aeddc47e83ff&quot; iex&gt; Caustic.Utils . base58_decode ( &quot;5J3mBbAH58CpQ3Y5RNJpUKPE62SQ5tfcvU2JpbnkeyhfsYB1Jcn&quot; , prefix : false ) &quot;801e99423a4ed27608a15a2616a2b0e9e52ced330ac530edcc32c8ffc6a526aeddc47e83ff&quot;","ref":"Caustic.Utils.html#base58_decode/2","title":"Caustic.Utils.base58_decode/2","type":"function"},{"doc":"Encodes an integer into its base58 representation. If given a string, by default it will interpret the string as a hex. If given hex and it has leading zeros, then each byte of zeros will be encoded as 1. Examples iex&gt; Caustic.Utils . base58_encode ( &quot;801e99423a4ed27608a15a2616a2b0e9e52ced330ac530edcc32c8ffc6a526aeddc47e83ff&quot; ) &quot;5J3mBbAH58CpQ3Y5RNJpUKPE62SQ5tfcvU2JpbnkeyhfsYB1Jcn&quot; iex&gt; Caustic.Utils . base58_encode ( &lt;&lt; 57 &gt;&gt; , convert_from_hex : false ) &quot;z&quot; iex&gt; Caustic.Utils . base58_encode ( 63716817338599314535577169638518475271320430400871647684951348108655027767484127754748927 ) &quot;5J3mBbAH58CpQ3Y5RNJpUKPE62SQ5tfcvU2JpbnkeyhfsYB1Jcn&quot; iex&gt; Caustic.Utils . base58_encode ( &quot;0x000001&quot; ) &quot;112&quot;","ref":"Caustic.Utils.html#base58_encode/2","title":"Caustic.Utils.base58_encode/2","type":"function"},{"doc":"Same as base58_decode but outputs an integer instead of hex string.","ref":"Caustic.Utils.html#base58_to_integer/1","title":"Caustic.Utils.base58_to_integer/1","type":"function"},{"doc":"","ref":"Caustic.Utils.html#base58_version/1","title":"Caustic.Utils.base58_version/1","type":"function"},{"doc":"Returns checksum, payload, and version Examples iex&gt; Caustic.Utils . base58check_decode &quot;5J3mBbAH58CpQ3Y5RNJpUKPE62SQ5tfcvU2JpbnkeyhfsYB1Jcn&quot; { :ok , &lt;&lt; 196 , 126 , 131 , 255 &gt;&gt; , &quot;1e99423a4ed27608a15a2616a2b0e9e52ced330ac530edcc32c8ffc6a526aedd&quot; , :private_key_wif } iex&gt; Caustic.Utils . base58check_decode &quot;1J7mdg5rbQyUHENYdx39WVWK7fsLpEoXZy&quot; { :ok , &lt;&lt; 55 , 254 , 252 , 208 &gt;&gt; , &quot;bbc1e42a39d05a4cc61752d6963b7f69d09bb27b&quot; , :address }","ref":"Caustic.Utils.html#base58check_decode/1","title":"Caustic.Utils.base58check_decode/1","type":"function"},{"doc":"Encodes a binary to its base58check representation. Possible values for version: :address , :address_p2sh , :address_testnet , private_key_wif , private_key_bip38_encrypted , public_key_bit32_extended Can also use custom binary version. Examples iex&gt; Caustic.Utils . base58check_encode ( &quot;0x1e99423a4ed27608a15a2616a2b0e9e52ced330ac530edcc32c8ffc6a526aedd&quot; , :private_key_wif ) &quot;5J3mBbAH58CpQ3Y5RNJpUKPE62SQ5tfcvU2JpbnkeyhfsYB1Jcn&quot; iex&gt; Caustic.Utils . base58check_encode ( &lt;&lt; Caustic.Utils . to_integer ( &quot;0x1e99423a4ed27608a15a2616a2b0e9e52ced330ac530edcc32c8ffc6a526aedd&quot; ) :: size ( 256 ) &gt;&gt; , :private_key_wif , convert_from_hex : false ) &quot;5J3mBbAH58CpQ3Y5RNJpUKPE62SQ5tfcvU2JpbnkeyhfsYB1Jcn&quot; iex&gt; Caustic.Utils . base58check_encode ( &lt;&lt; Caustic.Utils . to_integer ( &quot;0x1e99423a4ed27608a15a2616a2b0e9e52ced330ac530edcc32c8ffc6a526aedd&quot; ) :: size ( 256 ) , 0x01 &gt;&gt; , :private_key_wif , convert_from_hex : false ) &quot;KxFC1jmwwCoACiCAWZ3eXa96mBM6tb3TYzGmf6YwgdGWZgawvrtJ&quot; iex&gt; Caustic.Utils . base58check_encode ( &lt;&lt; Caustic.Utils . to_integer ( &quot;1E99423A4ED27608A15A2616A2B0E9E52CED330AC530EDCC32C8FFC6A526AEDD&quot; , 16 ) :: size ( 256 ) , 0x01 &gt;&gt; , :private_key_wif , convert_from_hex : false ) &quot;KxFC1jmwwCoACiCAWZ3eXa96mBM6tb3TYzGmf6YwgdGWZgawvrtJ&quot; iex&gt; Caustic.Utils . base58check_encode ( &quot;f5f2d624cfb5c3f66d06123d0829d1c9cebf770e&quot; , :address ) &quot;1PRTTaJesdNovgne6Ehcdu1fpEdX7913CK&quot; iex&gt; Caustic.Utils . base58check_encode ( &quot;000000cb23faea20aa20f02a02955ffd1d785518&quot; , :address ) &quot;1111DVWAb9XQh88gakJRcK14e1i1onvAL&quot; # private key is 5KjhZsxt61XSPunjrPm8XUEAH1YN6zXm6pqT5D1hZ9mLoEAqKTp","ref":"Caustic.Utils.html#base58check_encode/3","title":"Caustic.Utils.base58check_encode/3","type":"function"},{"doc":"Decodes a MIME Base64 encoded string. https://en.wikipedia.org/wiki/Base64 (see Variants summary table) Examples iex&gt; Caustic.Utils . base64_decode ( &quot;TWFu&quot; ) &quot;Man&quot; iex&gt; Caustic.Utils . base64_decode ( &quot;TWE=&quot; ) &quot;Ma&quot; iex&gt; Caustic.Utils . base64_decode ( &quot;TQ==&quot; ) &quot;M&quot; iex&gt; Caustic.Utils . base64_decode ( &quot;TWFuIGlzIGRpc3Rpbmd1aXNoZWQsIG5vdCBvbmx5IGJ5IGhpcyByZWFzb24sIGJ1dCBieSB0aGlz \\r \\n IHNpbmd1bGFyIHBhc3Npb24gZnJvbSBvdGhlciBhbmltYWxzLi4u&quot; ) &quot;Man is distinguished, not only by his reason, but by this singular passion from other animals...&quot;","ref":"Caustic.Utils.html#base64_decode/1","title":"Caustic.Utils.base64_decode/1","type":"function"},{"doc":"Gets the character code of a MIME base64 digit. Examples iex&gt; Caustic.Utils . base64_decode_char ( &quot;A&quot; ) 0 iex&gt; Caustic.Utils . base64_decode_char ( &quot;F&quot; ) 5 iex&gt; Caustic.Utils . base64_decode_char ( &quot;a&quot; ) 26 iex&gt; Caustic.Utils . base64_decode_char ( &quot;f&quot; ) 31 iex&gt; Caustic.Utils . base64_decode_char ( &quot;0&quot; ) 52 iex&gt; Caustic.Utils . base64_decode_char ( &quot;5&quot; ) 57 iex&gt; Caustic.Utils . base64_decode_char ( &quot;+&quot; ) 62 iex&gt; Caustic.Utils . base64_decode_char ( &quot;/&quot; ) 63","ref":"Caustic.Utils.html#base64_decode_char/1","title":"Caustic.Utils.base64_decode_char/1","type":"function"},{"doc":"Encodes a string into its MIME Base64 representation. https://en.wikipedia.org/wiki/Base64 (see Variants summary table) Examples iex&gt; Caustic.Utils . base64_encode ( &quot;Man&quot; ) &quot;TWFu&quot; iex&gt; Caustic.Utils . base64_encode ( &quot;Ma&quot; ) &quot;TWE=&quot; iex&gt; Caustic.Utils . base64_encode ( &quot;M&quot; ) &quot;TQ==&quot; iex&gt; Caustic.Utils . base64_encode ( &quot;Man is distinguished, not only by his reason, but by this singular passion from other animals...&quot; ) &quot;TWFuIGlzIGRpc3Rpbmd1aXNoZWQsIG5vdCBvbmx5IGJ5IGhpcyByZWFzb24sIGJ1dCBieSB0aGlz \\r \\n IHNpbmd1bGFyIHBhc3Npb24gZnJvbSBvdGhlciBhbmltYWxzLi4u&quot; iex&gt; Caustic.Utils . base64_encode ( &quot;Man is distinguished, not only by his reason, but by this singular passion from other animals...&quot; , new_line : false ) &quot;TWFuIGlzIGRpc3Rpbmd1aXNoZWQsIG5vdCBvbmx5IGJ5IGhpcyByZWFzb24sIGJ1dCBieSB0aGlzIHNpbmd1bGFyIHBhc3Npb24gZnJvbSBvdGhlciBhbmltYWxzLi4u&quot;","ref":"Caustic.Utils.html#base64_encode/2","title":"Caustic.Utils.base64_encode/2","type":"function"},{"doc":"Encodes an integer codepoint 0 &lt;= n &lt;= 63 to its MIME Base64 character. Examples iex&gt; Caustic.Utils . base64_encode_char ( 0 ) &quot;A&quot; iex&gt; Caustic.Utils . base64_encode_char ( 5 ) &quot;F&quot; iex&gt; Caustic.Utils . base64_encode_char ( 26 ) &quot;a&quot; iex&gt; Caustic.Utils . base64_encode_char ( 31 ) &quot;f&quot; iex&gt; Caustic.Utils . base64_encode_char ( 52 ) &quot;0&quot; iex&gt; Caustic.Utils . base64_encode_char ( 57 ) &quot;5&quot; iex&gt; Caustic.Utils . base64_encode_char ( 62 ) &quot;+&quot; iex&gt; Caustic.Utils . base64_encode_char ( 63 ) &quot;/&quot;","ref":"Caustic.Utils.html#base64_encode_char/1","title":"Caustic.Utils.base64_encode_char/1","type":"function"},{"doc":"Lists the exponents of n when n is represented as binary. For example, 34 in binary is 100010 or 2^5 + 2^1 , so the function will return [1, 5] . Examples iex&gt; Caustic.Utils . binary_exponents ( 0 ) [ ] iex&gt; Caustic.Utils . binary_exponents ( 2 ) [ 1 ] iex&gt; Caustic.Utils . binary_exponents ( 32 ) [ 5 ] iex&gt; Caustic.Utils . binary_exponents ( 33 ) [ 0 , 5 ]","ref":"Caustic.Utils.html#binary_exponents/1","title":"Caustic.Utils.binary_exponents/1","type":"function"},{"doc":"Converts a Bitcoin 256-bit private key to the Wallet Import Format. Defaults to outputting compressed format. Examples iex&gt; Caustic.Utils . bitcoin_private_key_to_wif ( &quot;1e99423a4ed27608a15a2616a2b0e9e52ced330ac530edcc32c8ffc6a526aedd&quot; ) &quot;KxFC1jmwwCoACiCAWZ3eXa96mBM6tb3TYzGmf6YwgdGWZgawvrtJ&quot; iex&gt; Caustic.Utils . bitcoin_private_key_to_wif ( &quot;1e99423a4ed27608a15a2616a2b0e9e52ced330ac530edcc32c8ffc6a526aedd&quot; , compressed : false ) &quot;5J3mBbAH58CpQ3Y5RNJpUKPE62SQ5tfcvU2JpbnkeyhfsYB1Jcn&quot;","ref":"Caustic.Utils.html#bitcoin_private_key_to_wif/2","title":"Caustic.Utils.bitcoin_private_key_to_wif/2","type":"function"},{"doc":"Converts a bitstring (including binary) into array of 0s and 1s. For simple binary you can also use :binary.decode_unsigned Examples iex&gt; Caustic.Utils . bitstring_to_array &quot;Hey&quot; [ 0 , 1 , 0 , 0 , 1 , 0 , 0 , 0 , 0 , 1 , 1 , 0 , 0 , 1 , 0 , 1 , 0 , 1 , 1 , 1 , 1 , 0 , 0 , 1 ] iex&gt; Caustic.Utils . bitstring_to_array &lt;&lt; 1 :: size ( 1 ) , 0 :: size ( 1 ) , 1 :: size ( 1 ) &gt;&gt; [ 1 , 0 , 1 ]","ref":"Caustic.Utils.html#bitstring_to_array/1","title":"Caustic.Utils.bitstring_to_array/1","type":"function"},{"doc":"Interprets a bitstring (including binary) as an unsigned integer. You can use :binary.decode_unsigned/1 if it's a normal binary. Examples iex&gt; Caustic.Utils . bitstring_to_integer ( &lt;&lt; 255 , 255 &gt;&gt; ) 65535","ref":"Caustic.Utils.html#bitstring_to_integer/1","title":"Caustic.Utils.bitstring_to_integer/1","type":"function"},{"doc":"Checks whether an integer n &gt; 1 is a composite number. 1 is a unit, neither a prime nor composite. Will return false on n &lt;= 1 . Examples iex&gt; Caustic.Utils . composite? ( 4 ) true iex&gt; Caustic.Utils . composite? ( 2 ) false iex&gt; Caustic.Utils . composite? ( 3 ) false iex&gt; Caustic.Utils . composite? ( 1 ) false","ref":"Caustic.Utils.html#composite?/1","title":"Caustic.Utils.composite?/1","type":"function"},{"doc":"Checks whether an integer is deficient. An integer n is abundant if and only if σ(n) - n &lt; n . Examples iex&gt; Caustic.Utils . abundant? ( 6 ) false","ref":"Caustic.Utils.html#deficient?/1","title":"Caustic.Utils.deficient?/1","type":"function"},{"doc":"Checks whether a divides b . See https://math.stackexchange.com/questions/666103/why-would-some-elementary-number-theory-notes-exclude-00 and https://math.stackexchange.com/questions/2174535/does-zero-divide-zero Examples iex&gt; Caustic.Utils . divides ( 2 , 8 ) true iex&gt; Caustic.Utils . divides ( 2 , 3 ) false iex&gt; Caustic.Utils . divides ( 2 , 0 ) true iex&gt; Caustic.Utils . divides ( 0 , 0 ) true","ref":"Caustic.Utils.html#divides/2","title":"Caustic.Utils.divides/2","type":"function"},{"doc":"Gets all the positive divisors of an integer. Examples iex&gt; Caustic.Utils . divisors ( 1 ) [ 1 ] iex&gt; Caustic.Utils . divisors ( 3 ) [ 1 , 3 ] iex&gt; Caustic.Utils . divisors ( 6 ) [ 1 , 2 , 3 , 6 ] iex&gt; Caustic.Utils . divisors ( - 4 ) [ 1 , 2 , 4 ]","ref":"Caustic.Utils.html#divisors/1","title":"Caustic.Utils.divisors/1","type":"function"},{"doc":"Counts how many positive divisors an integer has. d(n) . Examples iex&gt; Caustic.Utils . divisors_count ( 1 ) 1 iex&gt; Caustic.Utils . divisors_count ( 3 ) 2 iex&gt; Caustic.Utils . divisors_count ( 6 ) 4","ref":"Caustic.Utils.html#divisors_count/1","title":"Caustic.Utils.divisors_count/1","type":"function"},{"doc":"Sums the positive divisors of an integer. σ(n) . Examples iex&gt; Caustic.Utils . divisors_sum ( 1 ) 1 iex&gt; Caustic.Utils . divisors_sum ( 3 ) 4 iex&gt; Caustic.Utils . divisors_sum ( 6 ) 12","ref":"Caustic.Utils.html#divisors_sum/1","title":"Caustic.Utils.divisors_sum/1","type":"function"},{"doc":"The sum of the e -th power of the positive divisors of an integer. σ_e(n) . For example, the divisors of 15 are 1, 3, 5, and 15, so σ_2(15) = 1 + 3^2 + 5^2 + 15^2 = 260 Examples iex&gt; Caustic.Utils . divisors_sum ( 5 , 0 ) 2 iex&gt; Caustic.Utils . divisors_sum ( 5 , 1 ) 6 iex&gt; Caustic.Utils . divisors_sum ( 5 , 2 ) 26 iex&gt; Caustic.Utils . divisors_sum ( 15 , 2 ) 260","ref":"Caustic.Utils.html#divisors_sum/2","title":"Caustic.Utils.divisors_sum/2","type":"function"},{"doc":"","ref":"Caustic.Utils.html#exponentiation_table_mod/1","title":"Caustic.Utils.exponentiation_table_mod/1","type":"function"},{"doc":"","ref":"Caustic.Utils.html#exponentiation_table_mod/3","title":"Caustic.Utils.exponentiation_table_mod/3","type":"function"},{"doc":"","ref":"Caustic.Utils.html#factorial/1","title":"Caustic.Utils.factorial/1","type":"function"},{"doc":"Find the prime factors of an integer. Examples iex&gt; Caustic.Utils . factorize ( 72 ) [ 2 , 2 , 2 , 3 , 3 ] iex&gt; Caustic.Utils . factorize ( 480 ) [ 2 , 2 , 2 , 2 , 2 , 3 , 5 ] iex&gt; Caustic.Utils . factorize ( 357171293798123 ) [ 7 , 181 , 1459 , 193216691 ] iex&gt; Caustic.Utils . factorize ( 100000001 ) [ 17 , 5882353 ] iex&gt; Caustic.Utils . factorize ( 9223372036854775807 ) # largest 64-bit integer [ 7 , 7 , 73 , 127 , 337 , 92737 , 649657 ] iex&gt; Caustic.Utils . factorize ( 18446744073709551615 ) # largest 64-bit unsigned integer [ 3 , 5 , 17 , 257 , 641 , 65537 , 6700417 ] iex&gt; Caustic.Utils . factorize ( 18446744073709551615 * 3571 * 5901331 ) [ 3 , 5 , 17 , 257 , 641 , 3571 , 65537 , 5901331 , 6700417 ] iex&gt; Caustic.Utils . factorize ( 1 ) [ ]","ref":"Caustic.Utils.html#factorize/1","title":"Caustic.Utils.factorize/1","type":"function"},{"doc":"Find the prime factors and their exponents of an integer. Examples iex&gt; Caustic.Utils . factorize_grouped ( 9 ) [ { 3 , 2 } ] iex&gt; Caustic.Utils . factorize_grouped ( 72 ) [ { 2 , 3 } , { 3 , 2 } ] iex&gt; Caustic.Utils . factorize_grouped ( 480 ) [ { 2 , 5 } , { 3 , 1 } , { 5 , 1 } ] iex&gt; Caustic.Utils . factorize_grouped ( 357171293798123 ) [ { 7 , 1 } , { 181 , 1 } , { 1459 , 1 } , { 193216691 , 1 } ] iex&gt; Caustic.Utils . factorize_grouped ( 100000001 ) [ { 17 , 1 } , { 5882353 , 1 } ] iex&gt; Caustic.Utils . factorize_grouped ( 9223372036854775807 ) # largest 64-bit integer [ { 7 , 2 } , { 73 , 1 } , { 127 , 1 } , { 337 , 1 } , { 92737 , 1 } , { 649657 , 1 } ] iex&gt; Caustic.Utils . factorize_grouped ( 18446744073709551615 ) # largest 64-bit unsigned integer [ { 3 , 1 } , { 5 , 1 } , { 17 , 1 } , { 257 , 1 } , { 641 , 1 } , { 65537 , 1 } , { 6700417 , 1 } ] iex&gt; Caustic.Utils . factorize_grouped ( 18446744073709551615 * 3571 * 5901331 ) [ { 3 , 1 } , { 5 , 1 } , { 17 , 1 } , { 257 , 1 } , { 641 , 1 } , { 3571 , 1 } , { 65537 , 1 } , { 5901331 , 1 } , { 6700417 , 1 } ] iex&gt; Caustic.Utils . factorize ( 1 ) [ ]","ref":"Caustic.Utils.html#factorize_grouped/1","title":"Caustic.Utils.factorize_grouped/1","type":"function"},{"doc":"Finds the smallest prime divisor of a number and the result of dividing by that prime. The factorization of 1 is 1 1 and 0 is 0 1. Examples iex&gt; Caustic.Utils . factorize_once ( 20 ) { 2 , 10 } iex&gt; Caustic.Utils . factorize_once ( 11 ) { 11 , 1 } iex&gt; Caustic.Utils . factorize_once ( 1 ) { 1 , 1 } iex&gt; Caustic.Utils . factorize_once ( 0 ) { 0 , 1 } iex&gt; Caustic.Utils . factorize_once ( - 20 ) { - 2 , 10 }","ref":"Caustic.Utils.html#factorize_once/1","title":"Caustic.Utils.factorize_once/1","type":"function"},{"doc":"Find the greatest common divisor of two integers. Proof: https://www.khanacademy.org/computing/computer-science/cryptography/modarithmetic/a/the-euclidean-algorithm Examples iex&gt; Caustic.Utils . gcd ( 1 , 0 ) 1 iex&gt; Caustic.Utils . gcd ( - 1 , 0 ) 1 iex&gt; Caustic.Utils . gcd ( 270 , 192 ) 6 iex&gt; Caustic.Utils . gcd ( - 270 , 192 ) 6 iex&gt; Caustic.Utils . gcd ( 270 , - 192 ) 6 iex&gt; Caustic.Utils . gcd ( - 270 , - 192 ) 6","ref":"Caustic.Utils.html#gcd/2","title":"Caustic.Utils.gcd/2","type":"function"},{"doc":"Find the greatest common divisor d of two integers a and b , while also finding the coefficients x and y such that ax + by = d . Examples iex&gt; Caustic.Utils . gcd_with_coefficients ( 3 , 0 ) { 3 , 1 , 0 } iex&gt; Caustic.Utils . gcd_with_coefficients ( 6 , 3 ) { 3 , 0 , 1 } iex&gt; Caustic.Utils . gcd_with_coefficients ( 270 , 192 ) { 6 , 5 , - 7 } iex&gt; Caustic.Utils . gcd_with_coefficients ( - 270 , 192 ) { 6 , - 5 , - 7 } iex&gt; Caustic.Utils . gcd_with_coefficients ( 270 , - 192 ) { 6 , 5 , 7 } iex&gt; Caustic.Utils . gcd_with_coefficients ( - 270 , - 192 ) { 6 , - 5 , 7 } iex&gt; Caustic.Utils . gcd_with_coefficients ( 314 , 159 ) { 1 , - 40 , 79 }","ref":"Caustic.Utils.html#gcd_with_coefficients/2","title":"Caustic.Utils.gcd_with_coefficients/2","type":"function"},{"doc":"Guess the base of an integer string using its prefix. Defaults to 10, and doesn't check for validity of the digits. Examples iex&gt; Caustic.Utils . get_base ( &quot;0xabf&quot; ) 16 iex&gt; Caustic.Utils . get_base ( &quot;0b101&quot; ) 2 iex&gt; Caustic.Utils . get_base ( &quot;321&quot; ) 10","ref":"Caustic.Utils.html#get_base/1","title":"Caustic.Utils.get_base/1","type":"function"},{"doc":"Calculate the document hash, used for ECDSA.","ref":"Caustic.Utils.html#hash256/1","title":"Caustic.Utils.hash256/1","type":"function"},{"doc":"Removes hexadecimal prefix from a string. Examples iex&gt; Caustic.Utils . hex_remove_prefix ( &quot;0xff&quot; ) &quot;ff&quot; iex&gt; Caustic.Utils . hex_remove_prefix ( &quot;0XFF&quot; ) &quot;FF&quot; iex&gt; Caustic.Utils . hex_remove_prefix ( &quot;ff&quot; ) &quot;ff&quot;","ref":"Caustic.Utils.html#hex_remove_prefix/1","title":"Caustic.Utils.hex_remove_prefix/1","type":"function"},{"doc":"Solves the linear congruence ax = b (mod m). Examples iex&gt; Caustic.Utils . linear_congruence_solve ( 1 , 3 , 4 ) [ 3 ] iex&gt; Caustic.Utils . linear_congruence_solve ( 2 , 1 , 4 ) [ ] iex&gt; Caustic.Utils . linear_congruence_solve ( 2 , 6 , 4 ) [ 1 , 3 ] iex&gt; Caustic.Utils . linear_congruence_solve ( 0 , 0 , 3 ) [ 0 , 1 , 2 ] iex&gt; Caustic.Utils . linear_congruence_solve ( 0 , 1 , 3 ) [ ] iex&gt; Caustic.Utils . linear_congruence_solve ( 0 , 2 , 3 ) [ ] iex&gt; Caustic.Utils . linear_congruence_solve ( 0 , 3 , 3 ) [ 0 , 1 , 2 ]","ref":"Caustic.Utils.html#linear_congruence_solve/3","title":"Caustic.Utils.linear_congruence_solve/3","type":"function"},{"doc":"Splits a list into its first n elements and the rest. Examples iex&gt; Caustic.Utils . list_split ( [ 1 , 2 , 3 , 4 , 5 ] , 2 ) { [ 1 , 2 ] , [ 3 , 4 , 5 ] } iex&gt; Caustic.Utils . list_split ( [ 1 , 2 , 3 ] , 5 ) { [ 1 , 2 , 3 ] , [ ] }","ref":"Caustic.Utils.html#list_split/2","title":"Caustic.Utils.list_split/2","type":"function"},{"doc":"The base 2 logarithm of an integer and its remainder. For example, 9 = 2^3 + 1, so log2i(9) = 3 with remainder 1. Examples iex&gt; Caustic.Utils . log2i ( 9 ) { 3 , 1 } iex&gt; Caustic.Utils . log2i ( 8 ) { 3 , 0 } iex&gt; Caustic.Utils . log2i ( 256 ) { 8 , 0 }","ref":"Caustic.Utils.html#log2i/1","title":"Caustic.Utils.log2i/1","type":"function"},{"doc":"Calculate the md5 hash.","ref":"Caustic.Utils.html#md5/1","title":"Caustic.Utils.md5/1","type":"function"},{"doc":"https://oeis.org/A000043 https://en.wikipedia.org/wiki/Mersenne_prime The first n Mersenne exponents, primes p such that 2^p - 1 is prime. Examples iex&gt; Caustic.Utils . mersenne_exponents_first ( 5 ) [ 2 , 3 , 5 , 7 , 13 ]","ref":"Caustic.Utils.html#mersenne_exponents_first/1","title":"Caustic.Utils.mersenne_exponents_first/1","type":"function"},{"doc":"https://oeis.org/A000668 https://en.wikipedia.org/wiki/Mersenne_prime The i -th Mersenne prime, starting at index 0. Primes of the form 2^p - 1 where p is a prime. Examples iex&gt; Caustic.Utils . mersenne_prime ( 0 ) 3","ref":"Caustic.Utils.html#mersenne_prime/1","title":"Caustic.Utils.mersenne_prime/1","type":"function"},{"doc":"Finds the least residue of a number modulo m . Examples iex&gt; Caustic.Utils . mod ( 0 , 3 ) 0 iex&gt; Caustic.Utils . mod ( - 27 , 13 ) 12 iex&gt; Caustic.Utils . mod ( - 3 , 3 ) 0","ref":"Caustic.Utils.html#mod/2","title":"Caustic.Utils.mod/2","type":"function"},{"doc":"Find the modular inverse (modular multiplicative inverse). Using Euclidean Algorithm: https://www.math.utah.edu/~fguevara/ACCESS2013/Euclid.pdf Examples iex&gt; Caustic.Utils . mod_inverse ( 1 , 101 ) 1 iex&gt; Caustic.Utils . mod_inverse ( 2 , 3 ) 2 iex&gt; Caustic.Utils . mod_inverse ( 50 , 71 ) 27 iex&gt; Caustic.Utils . mod_inverse ( 25 , 50 ) nil iex&gt; Caustic.Utils . mod_inverse ( 8 , 11 ) 7 iex&gt; Caustic.Utils . mod_inverse ( 345 , 76408 ) 48281 iex&gt; Caustic.Utils . mod_inverse ( 71 , 50 ) 31 # Bitcoin elliptic curve iex&gt; Caustic.Utils . mod_inverse ( 345 , 115792089237316195423570985008687907853269984665640564039457584007908834671663 ) 53029420578249156164997726467746925915410601672960026429664632676085785153979","ref":"Caustic.Utils.html#mod_inverse/2","title":"Caustic.Utils.mod_inverse/2","type":"function"},{"doc":"","ref":"Caustic.Utils.html#multiplication_table_mod/1","title":"Caustic.Utils.multiplication_table_mod/1","type":"function"},{"doc":"Finds the first integer n where n &gt;= from satisfying some property.","ref":"Caustic.Utils.html#next/3","title":"Caustic.Utils.next/3","type":"function"},{"doc":"The smallest number t such that a^t = 1 (mod m) .","ref":"Caustic.Utils.html#order_multiplicative/2","title":"Caustic.Utils.order_multiplicative/2","type":"function"},{"doc":"Determines whether an integer is a perfect number. A number n is perfect iff σ(n) - n = n . Examples iex&gt; Caustic.Utils . perfect? ( 6 ) true iex&gt; Caustic.Utils . perfect? ( 5 ) false","ref":"Caustic.Utils.html#perfect?/1","title":"Caustic.Utils.perfect?/1","type":"function"},{"doc":"Determines whether an integer is a k-perfect number. A number n is k-perfect iff σ(n) = kn . Perfect numbers are 2-perfect. Examples iex&gt; Caustic.Utils . perfect? ( 6 , 2 ) true iex&gt; Caustic.Utils . perfect? ( 672 , 3 ) true iex&gt; Caustic.Utils . perfect? ( 2178540 , 4 ) true","ref":"Caustic.Utils.html#perfect?/2","title":"Caustic.Utils.perfect?/2","type":"function"},{"doc":"","ref":"Caustic.Utils.html#pmap/2","title":"Caustic.Utils.pmap/2","type":"function"},{"doc":"Calculates integer exponentiation. Exponent can be negative. Examples iex&gt; Caustic.Utils . pow ( 3 , 9 ) 19683 iex&gt; Caustic.Utils . pow ( 2 , 8 ) 256 iex&gt; Caustic.Utils . pow ( 2 , 256 ) 115792089237316195423570985008687907853269984665640564039457584007913129639936 iex&gt; Caustic.Utils . pow ( 2 , - 2 ) 0.25","ref":"Caustic.Utils.html#pow/2","title":"Caustic.Utils.pow/2","type":"function"},{"doc":"Fast exponentiation modulo m. Calculates x^y mod m. With x = 5, y = 12345, m = 17, and repeated 1000 times, it is faster by naive method by a factor of 150 on a particular benchmark machine. https://www.khanacademy.org/computing/computer-science/cryptography/modarithmetic/a/modular-exponentiation https://www.khanacademy.org/computing/computer-science/cryptography/modarithmetic/a/fast-modular-exponentiation Examples iex&gt; Caustic.Utils . pow_mod ( 5 , 0 , 19 ) 1 iex&gt; Caustic.Utils . pow_mod ( 5 , 1 , 19 ) 5 iex&gt; Caustic.Utils . pow_mod ( 5 , 117 , 19 ) 1 iex&gt; Caustic.Utils . pow_mod ( 7 , 256 , 13 ) 9 iex&gt; Caustic.Utils . pow_mod ( 2 , 90 , 13 ) 12 iex&gt; Caustic.Utils . pow_mod ( 50 , - 1 , 71 ) 27 iex&gt; Caustic.Utils . pow_mod ( 7 , - 3 , 13 ) 8","ref":"Caustic.Utils.html#pow_mod/3","title":"Caustic.Utils.pow_mod/3","type":"function"},{"doc":"The i -th prime, starting at index 0. Examples iex&gt; Caustic.Utils . prime ( 0 ) 2 iex&gt; Caustic.Utils . prime ( 1 ) 3 iex&gt; Caustic.Utils . prime ( 1999 ) 17389 iex&gt; Caustic.Utils . prime ( 2000 ) 17393 iex&gt; Caustic.Utils . prime ( 9999 ) 104729 iex&gt; Caustic.Utils . prime ( 49999 ) 611953 iex&gt; Caustic.Utils . prime ( 99999 ) 1299709 iex&gt; Caustic.Utils . prime ( 199999 ) 2750159","ref":"Caustic.Utils.html#prime/1","title":"Caustic.Utils.prime/1","type":"function"},{"doc":"Checks whether an integer is a prime. Examples iex&gt; Caustic.Utils . prime? ( 1 ) false iex&gt; Caustic.Utils . prime? ( 2 ) true iex&gt; Caustic.Utils . prime? ( 3 ) true iex&gt; Caustic.Utils . prime? ( 4 ) false iex&gt; Caustic.Utils . prime? ( 5882353 * 5882353 ) false","ref":"Caustic.Utils.html#prime?/1","title":"Caustic.Utils.prime?/1","type":"function"},{"doc":"Checks whether an integer is a prime using Sieve of Eratosthenes algorithm. Don't use on very large numbers.","ref":"Caustic.Utils.html#prime_sieve?/1","title":"Caustic.Utils.prime_sieve?/1","type":"function"},{"doc":"Find all primes p ≤ n using Sieve of Eratosthenes method. Examples iex&gt; Caustic.Utils . prime_sieve_up_to ( 10 ) [ 2 , 3 , 5 , 7 ] iex&gt; Caustic.Utils . prime_sieve_up_to ( 30 ) [ 2 , 3 , 5 , 7 , 11 , 13 , 17 , 19 , 23 , 29 ] iex&gt; Caustic.Utils . prime_sieve_up_to ( 100 ) [ 2 , 3 , 5 , 7 , 11 , 13 , 17 , 19 , 23 , 29 , 31 , 37 , 41 , 43 , 47 , 53 , 59 , 61 , 67 , 71 , 73 , 79 , 83 , 89 , 97 ]","ref":"Caustic.Utils.html#prime_sieve_up_to/1","title":"Caustic.Utils.prime_sieve_up_to/1","type":"function"},{"doc":"The first n primes.","ref":"Caustic.Utils.html#primes_first/1","title":"Caustic.Utils.primes_first/1","type":"function"},{"doc":"Checks whether a number n is a primitive root modulo m . Examples iex&gt; Caustic.Utils . primitive_root? ( 1 , 5 ) false iex&gt; Caustic.Utils . primitive_root? ( 4 , 5 ) false iex&gt; Caustic.Utils . primitive_root? ( 2 , 5 ) true","ref":"Caustic.Utils.html#primitive_root?/2","title":"Caustic.Utils.primitive_root?/2","type":"function"},{"doc":"Finds the primitive roots of a positive integer m . a is a primitive root of an integer m if a is a least residue and has order ( mod m ) of t = φ(n) . This means that t is the smallest number such that a^t = 1 (mod m) .","ref":"Caustic.Utils.html#primitive_roots/1","title":"Caustic.Utils.primitive_roots/1","type":"function"},{"doc":"Gets all the positive divisors of a number, excluding the number itself. Examples iex&gt; Caustic.Utils . proper_divisors ( 10 ) [ 1 , 2 , 5 ]","ref":"Caustic.Utils.html#proper_divisors/1","title":"Caustic.Utils.proper_divisors/1","type":"function"},{"doc":"Counts how many proper divisors an integer has. d(n) - 1 . Examples iex&gt; Caustic.Utils . proper_divisors_count ( 1 ) 0 iex&gt; Caustic.Utils . proper_divisors_count ( 3 ) 1 iex&gt; Caustic.Utils . proper_divisors_count ( 6 ) 3","ref":"Caustic.Utils.html#proper_divisors_count/1","title":"Caustic.Utils.proper_divisors_count/1","type":"function"},{"doc":"","ref":"Caustic.Utils.html#proper_divisors_sum/1","title":"Caustic.Utils.proper_divisors_sum/1","type":"function"},{"doc":"Removes the first element of a list.","ref":"Caustic.Utils.html#rest/1","title":"Caustic.Utils.rest/1","type":"function"},{"doc":"Examples iex&gt; Caustic.Utils . select ( [ [ :a , :b ] , [ 1 , 2 , 3 ] ] ) [ [ :a , 1 ] , [ :a , 2 ] , [ :a , 3 ] , [ :b , 1 ] , [ :b , 2 ] , [ :b , 3 ] ] iex&gt; Caustic.Utils . select ( [ [ [ &quot;hello&quot; ] , [ &quot;bye&quot; ] ] , [ &quot;world&quot; ] ] ) [ [ [ &quot;hello&quot; ] , &quot;world&quot; ] , [ [ &quot;bye&quot; ] , &quot;world&quot; ] ]","ref":"Caustic.Utils.html#select/1","title":"Caustic.Utils.select/1","type":"function"},{"doc":"Examples iex&gt; Caustic.Utils . smallest_prime_divisor ( 2 ) 2 iex&gt; Caustic.Utils . smallest_prime_divisor ( 4 ) 2 iex&gt; Caustic.Utils . smallest_prime_divisor ( 144 ) 2 iex&gt; Caustic.Utils . smallest_prime_divisor ( 5 ) 5 iex&gt; Caustic.Utils . smallest_prime_divisor ( 35 ) 5","ref":"Caustic.Utils.html#smallest_prime_divisor/1","title":"Caustic.Utils.smallest_prime_divisor/1","type":"function"},{"doc":"If n is a square number, return its root. Otherwise nil . Examples iex&gt; Caustic.Utils . sqrti ( 1 ) 1 iex&gt; Caustic.Utils . sqrti ( 4 ) 2 iex&gt; Caustic.Utils . sqrti ( 5 ) nil iex&gt; Caustic.Utils . sqrti ( - 1 ) nil","ref":"Caustic.Utils.html#sqrti/1","title":"Caustic.Utils.sqrti/1","type":"function"},{"doc":"Creates a lazy stream of integers satisfying some property.","ref":"Caustic.Utils.html#stream/4","title":"Caustic.Utils.stream/4","type":"function"},{"doc":"Finds the index of an ASCII character inside a string. Not unicode friendly! Examples iex&gt; Caustic.Utils . string_index_of ( &quot;Hello&quot; , &quot;H&quot; ) 0 iex&gt; Caustic.Utils . string_index_of ( &quot;Hello&quot; , &quot;h&quot; ) nil iex&gt; Caustic.Utils . string_index_of ( &quot;Hello&quot; , &quot;l&quot; ) 2","ref":"Caustic.Utils.html#string_index_of/2","title":"Caustic.Utils.string_index_of/2","type":"function"},{"doc":"Finds all subsets of a set (represented by a keyword list). Examples iex&gt; Caustic.Utils . subsets ( [ :a ] ) [ [ ] , [ :a ] ] iex&gt; Caustic.Utils . subsets ( [ :a , :b , :c ] ) [ [ ] , [ :a ] , [ :b ] , [ :c ] , [ :a , :b ] , [ :a , :c ] , [ :b , :c ] , [ :a , :b , :c ] ]","ref":"Caustic.Utils.html#subsets/1","title":"Caustic.Utils.subsets/1","type":"function"},{"doc":"Finds all subsets with cardinality n of a set (represented by a keyword list). Examples iex&gt; members = [ &quot;nakai&quot; , &quot;kusanagi&quot; , &quot;mori&quot; , &quot;kimura&quot; , &quot;katori&quot; , &quot;inagaki&quot; ] iex&gt; Caustic.Utils . subsets ( members , 3 ) [ [ &quot;nakai&quot; , &quot;kusanagi&quot; , &quot;mori&quot; ] , [ &quot;nakai&quot; , &quot;kusanagi&quot; , &quot;kimura&quot; ] , [ &quot;nakai&quot; , &quot;kusanagi&quot; , &quot;katori&quot; ] , [ &quot;nakai&quot; , &quot;kusanagi&quot; , &quot;inagaki&quot; ] , [ &quot;nakai&quot; , &quot;mori&quot; , &quot;kimura&quot; ] , [ &quot;nakai&quot; , &quot;mori&quot; , &quot;katori&quot; ] , [ &quot;nakai&quot; , &quot;mori&quot; , &quot;inagaki&quot; ] , [ &quot;nakai&quot; , &quot;kimura&quot; , &quot;katori&quot; ] , [ &quot;nakai&quot; , &quot;kimura&quot; , &quot;inagaki&quot; ] , [ &quot;nakai&quot; , &quot;katori&quot; , &quot;inagaki&quot; ] , [ &quot;kusanagi&quot; , &quot;mori&quot; , &quot;kimura&quot; ] , [ &quot;kusanagi&quot; , &quot;mori&quot; , &quot;katori&quot; ] , [ &quot;kusanagi&quot; , &quot;mori&quot; , &quot;inagaki&quot; ] , [ &quot;kusanagi&quot; , &quot;kimura&quot; , &quot;katori&quot; ] , [ &quot;kusanagi&quot; , &quot;kimura&quot; , &quot;inagaki&quot; ] , [ &quot;kusanagi&quot; , &quot;katori&quot; , &quot;inagaki&quot; ] , [ &quot;mori&quot; , &quot;kimura&quot; , &quot;katori&quot; ] , [ &quot;mori&quot; , &quot;kimura&quot; , &quot;inagaki&quot; ] , [ &quot;mori&quot; , &quot;katori&quot; , &quot;inagaki&quot; ] , [ &quot;kimura&quot; , &quot;katori&quot; , &quot;inagaki&quot; ] ]","ref":"Caustic.Utils.html#subsets/2","title":"Caustic.Utils.subsets/2","type":"function"},{"doc":"Determines whether an integer is a superperfect number. A number n is superperfect if and only if σ(σ(n)) = 2n . Examples iex&gt; Caustic.Utils . superperfect? ( 2 ) true iex&gt; Caustic.Utils . superperfect? ( 4 ) true iex&gt; Caustic.Utils . superperfect? ( 16 ) true iex&gt; Caustic.Utils . superperfect? ( 3 ) false","ref":"Caustic.Utils.html#superperfect?/1","title":"Caustic.Utils.superperfect?/1","type":"function"},{"doc":"Find the digits of a nonnegative integer n in a particular base . Examples iex&gt; Caustic.Utils . to_digits ( 321 , 10 ) [ 3 , 2 , 1 ] iex&gt; Caustic.Utils . to_digits ( 5 , 2 ) [ 1 , 0 , 1 ] iex&gt; Caustic.Utils . to_digits ( 255 , 16 ) [ 15 , 15 ] iex&gt; Caustic.Utils . to_digits ( 0 , 8 ) [ 0 ]","ref":"Caustic.Utils.html#to_digits/2","title":"Caustic.Utils.to_digits/2","type":"function"},{"doc":"Parse a string which can be in any base to integer, autodetecting the base using the prefix. Examples iex&gt; Caustic.Utils . to_integer ( &quot;0xff&quot; ) 255 iex&gt; Caustic.Utils . to_integer ( &quot;0b101&quot; ) 5 iex&gt; Caustic.Utils . to_integer ( &quot;321&quot; ) 321","ref":"Caustic.Utils.html#to_integer/1","title":"Caustic.Utils.to_integer/1","type":"function"},{"doc":"Parse a string which can be in any base to integer, specifying the base. Examples iex&gt; Caustic.Utils . to_integer ( &quot;ff&quot; , 16 ) 255 iex&gt; Caustic.Utils . to_integer ( &quot;101&quot; , 2 ) 5 iex&gt; Caustic.Utils . to_integer ( &quot;755&quot; , 8 ) 493 iex&gt; Caustic.Utils . to_integer ( &quot;321&quot; , 10 ) 321","ref":"Caustic.Utils.html#to_integer/2","title":"Caustic.Utils.to_integer/2","type":"function"},{"doc":"Convert an integer into its string representation in any base . Examples iex&gt; Caustic.Utils . to_string ( 255 , 16 ) &quot;0xff&quot; iex&gt; Caustic.Utils . to_string ( 255 , 16 , prefix : false ) &quot;ff&quot; iex&gt; Caustic.Utils . to_string ( 5 , 2 ) &quot;0b101&quot;","ref":"Caustic.Utils.html#to_string/3","title":"Caustic.Utils.to_string/3","type":"function"},{"doc":"If an integer can be written as the sum of the squares of two positive integers, return those two integers {a, b} where a &lt;= b. Examples iex&gt; Caustic.Utils . to_sum_of_two_squares ( 17 ) { 1 , 4 } iex&gt; Caustic.Utils . to_sum_of_two_squares ( 1 ) nil","ref":"Caustic.Utils.html#to_sum_of_two_squares/1","title":"Caustic.Utils.to_sum_of_two_squares/1","type":"function"},{"doc":"Euler's totient function φ(n) . The number of positive integers less than or equal to m and relatively prime to m . Examples iex&gt; Caustic.Utils . totient ( 5 ) 4 iex&gt; Caustic.Utils . totient ( 6 ) 2 iex&gt; Caustic.Utils . totient ( 9 ) 6 iex&gt; Caustic.Utils . totient ( 1 ) 1 iex&gt; Caustic.Utils . totient ( 4200 ) 960","ref":"Caustic.Utils.html#totient/1","title":"Caustic.Utils.totient/1","type":"function"},{"doc":"Positive integers less than or equal to m and relatively prime to m . Examples iex&gt; Caustic.Utils . totient_members ( 1 ) [ 1 ] iex&gt; Caustic.Utils . totient_members ( 6 ) [ 1 , 5 ] iex&gt; Caustic.Utils . totient_members ( 9 ) [ 1 , 2 , 4 , 5 , 7 , 8 ] iex&gt; Caustic.Utils . totient_members ( 10 ) [ 1 , 3 , 7 , 9 ]","ref":"Caustic.Utils.html#totient_members/1","title":"Caustic.Utils.totient_members/1","type":"function"},{"doc":"Checks whether an integer is triangular. An integer is triangular if and only if it can be expressed as n(n + 1)/2 for some integer n . Examples iex&gt; Caustic.Utils . triangular? 0 true iex&gt; Caustic.Utils . triangular? 3 true iex&gt; Caustic.Utils . triangular? 4 false","ref":"Caustic.Utils.html#triangular?/1","title":"Caustic.Utils.triangular?/1","type":"function"},{"doc":"Finds the nonnegative integer m such that m(m + 1)/2 = n . Returns nil if no such number exists. Examples iex&gt; Caustic.Utils . triangular_root 6 3","ref":"Caustic.Utils.html#triangular_root/1","title":"Caustic.Utils.triangular_root/1","type":"function"},{"doc":"","ref":"Caustic.Utils.html#write_to_file/3","title":"Caustic.Utils.write_to_file/3","type":"function"},{"doc":"Caustic is an Elixir cryptocurrency library which contains algorithms used in Bitcoin, Ethereum, and other blockchains. It also includes a rich cryptography, number theory, and general mathematics class library. You can use Caustic to quickly implement your own crypto wallet or client. With the low-level math library, you can have fun with exploratory mathematics. Warning: This library is developed for learning purposes. Please do not use for production. Documentation https://hexdocs.pm/caustic/ Installation Add to mix.exs of your Elixir project: defp deps do [ { :caustic , &quot;~&gt; 0.1.22&quot; } ] end And then run: mix deps.get Usage","ref":"readme.html","title":"Caustic Cryptocurrency Library","type":"extras"},{"doc":"You can generate Bitcoin private keys. privkey = Caustic.Secp256k1 . generate_private_key ( ) # 55129182198667841522063226112743062531539377180872956850932941251085402073984 privkey_base58check = Caustic.Utils . base58check_encode ( &lt;&lt; privkey :: size ( 256 ) &gt;&gt; , :private_key_wif , convert_from_hex : false ) # 5Jjxv41cLxb3hBZRr5voBB7zj77MDo7QVVLf3XgK2tpdAoTNq9n You can then digitally sign a message. pubkey = Caustic.Secp256k1 . public_key ( privkey ) # {6316467786437337873577388437635743649101330733943708346103893494005928771381, 36516277665018688612645564779200795235396005730419130160033716279021320193545} message = &quot;Hello, world!!!&quot; hash = Caustic.Utils . hash256 ( message ) signature = Caustic.Secp256k1 . ecdsa_sign ( hash , privkey ) Caustic.Secp256k1 . ecdsa_verify? ( pubkey , hash , signature ) # true","ref":"readme.html#cryptocurrency","title":"Caustic Cryptocurrency Library - Cryptocurrency","type":"extras"},{"doc":"Caustic has many functions to deal with integers and their properties. For example you can do primality testing. first_primes = 1 .. 20 |&gt; Enum . filter ( &amp; Caustic.Utils . prime? / 1 ) # [2, 3, 5, 7, 11, 13, 17, 19] So 7 is supposed to be a prime. Let's confirm by finding its divisors: Caustic.Utils . divisors 7 # [1, 7] This is in contrast to 6 for example, which has divisors other than 1 and itself: Caustic.Utils . divisors 6 # [1, 2, 3, 6] The sum of 6's divisors other than itself (its proper divisors) equals to 6 again. Those kinds of numbers are called perfect numbers. Caustic.Utils . proper_divisors 6 # [1, 2, 3] Caustic.Utils . proper_divisors_sum 6 # 6 Caustic.Utils . perfect? 6 # true We can easily find other perfect numbers. 1 .. 10000 |&gt; Enum . filter ( &amp; Caustic.Utils . perfect? / 1 ) # [6, 28, 496, 8128] There aren't that many of them, it seems... Now back to our list of first primes. You can find the primitive roots of those primes: first_primes |&gt; Enum . map ( &amp; { &amp;1 , Caustic.Utils . primitive_roots ( &amp;1 ) } ) # [ # {2, [1]}, # {3, [2]}, # {5, [2, 3]}, # {7, [3, 5]}, # {11, [2, 6, 7, 8]}, # {13, [2, 6, 7, 11]}, # {17, [3, 5, 6, 7, 10, 11, 12, 14]}, # {19, [2, 3, 10, 13, 14, 15]} # ] We can see that 5 is a primitive root of 7. It means that repeated exponentiation of 5 modulo 7 will generate all numbers relatively prime to 7. Let's confirm it: Caustic.Utils . order_multiplicative 5 , 7 # 6 1 .. 6 |&gt; Enum . map ( &amp; Caustic.Utils . pow_mod ( 5 , &amp;1 , 7 ) ) # [5, 4, 6, 2, 3, 1] First we check the order of 5 modulo 7. It is 6, which means that 5^6 = 1 (mod 7), so further repeated multiplication (5^7 etc.) will just repeat previous values. Then we calculate 5^1 to 5^6 (mod 7), and as expected it cycles through all numbers relatively prime to 7 because 5 is a primitive root of 7. For more examples, please see the documentation of Caustic.Utils . Contribute Please send pull requests to https://github.com/agro1986/caustic Contact @agro1986 on Twitter","ref":"readme.html#number-theory","title":"Caustic Cryptocurrency Library - Number theory","type":"extras"}]